module PaperclipPrivate
	module Attachment

		def self.included(base)
			base.extend ClassMethods 
			base.prepend Initializer
		end

		module ClassMethods

			def default_options
				super.merge({privacy: :public})
			end

		end

		module Initializer
			def initialize(name, instance, options = {})
	      defaults = self.class.default_options.dup
	      privacy = options[:privacy]
        privacy = privacy.call(instance) if privacy.respond_to?(:call)
	      if privacy == :private # change default options if private before merging with options.
	        defaults[:path] = ":rails_root/:privacy#{defaults[:url]}"
	        defaults[:url] = "#{Rails.application.routes.url_helpers.paperclip_private_engine_path}/private/:klass/:id/:attachment_singular/:style" 
	      end
	      options = defaults.deep_merge(options)

	      super(name, instance, options)
	    end
		end

		

	end
end