module PaperclipPrivate

  module Errors
    # Wil be thrown if params validation fails in private controller.
    class ControllerValidationError < ::Paperclip::Error
    end

    # Will be thrown if file does not exist on server.
    class FileDoesNotExistError < ::Paperclip::Error
    end

    # Will be thrown if true is not returned from an attachment's owner's
    # can_download_attachment? method.
    class AccessDeniedError < ::Paperclip::Error
    end

  end
end