module PaperclipPrivate
	module Whitelist
		def self.registry
			@registry ||= {}
		end

		def self.names_for_class(klass)
			registry[klass] || []
		end

		def self.register_class(klass, name)
			return if klass.nil? || name.nil?
			class_name = klass.to_s
			registry[class_name] ||= []
			registry[class_name] << name.to_s
		end

		def self.register(hash = {})
			hash.each do |k, v|
				if v.is_a? Array
					v.each { |name| register_class(k, name) }
				else
					register_class(k, v)
				end
			end
		end

	end
end